{
Test program for UNZIP;
  Under Windows and OS/2, it uses the DLL (in UNZIPDLL.PAS), which must be
  compiled first
}

PROGRAM Test1;
{$I unzip.Inc}

{$ifdef Windows}
USES
{$ifndef __TMT__}
wintypes,
winprocs,
{$else}
windows,
messages,
{$endif}
{$ifdef Delphi} sysutils, {$else Delphi}windos, strings, {$endif Delphi}
zipinter,
Ziptypes,
wincrt;
{$else Windows}
USES
{$ifdef OS2}
Windows,
Sysutils,
{$else OS2}
strings,
{$endif OS2}
Ziptypes,
{$ifdef DPMI}
ZipInter;
{$else DPMI}
{$ifdef OS2}
ZipInter;
{$else OS2}
unzip;
{$endif OS2}
{$endif DPMI}
{$endif Windows}

VAR
SkipAll : Boolean;

PROCEDURE Report ( Retcode : longint;R : pReportRec );
{$ifdef Bits32}STDCALL;{$else}{$ifndef MSDOS}EXPORT;{$endif}{$endif}
BEGIN
  WITH r^ DO
  CASE Status of
  file_completed :
   Writeln
   (
   UnzipMethods [ packmethod ] : 9,
   '  ', Size : 9,
   '  ', CompressSize : 9,
   '  ', Ratio : 5, '%',
   '  ', strpas(filename)
   );
   unzip_completed :
   Writeln
   (
   'Archived' : 9,
   '  ', Size : 9,
   '  ', CompressSize : 9,
   '  ', Ratio : 5, '%',
   '  ', strpas(filename)
   );

 END {case}
END; {Report}
{/////////////////////////////////////////////////////}
FUNCTION Ask ( R : pReportRec ) : Boolean;
{$ifdef Bits32}STDCALL;{$else}{$ifndef MSDOS}EXPORT;{$endif}{$endif}
VAR
s : string [ 1 ];
BEGIN
   IF SkipAll THEN BEGIN
      Ask := FALSE;
      Exit;
   END;

   WITH r^
   DO BEGIN
     {$ifdef Windows}
       Ask := Messagebox
       ( 0,
       'The above file already exists! Should I overwrite it?',
       filename,
       mb_YESNO ) = id_Yes;

     {$else}
      Ask := FALSE;
      Writeln ( strpas(filename), ': (', Size, ' bytes)' );
      Write ( 'This file already exists! Overwrite? ([Y]es [N]o [S]kip all): ' );
      Readln ( s );
      CASE Upcase ( s [ 1 ] ) of
       'Y' : Ask := TRUE;
       'S' : BEGIN
              Ask := TRUE;
              Skipall := TRUE;
            END;
       END; {Case}
     {$endif Windows}
   END;
END; {Report}
{/////////////////////////////////////////////////////}
VAR
thename, target : ARRAY [ 0..TFSize ] of char;
DLLVersion, i : word;
NoRecursion : Boolean;
sname: string;

BEGIN
   {$ifdef Windows}
   WITH ScreenSize DO BEGIN
        x := 75;
        y := 500;
   END;
   WITH WindowOrg DO BEGIN
        x := 1;
        y := 1
   END;
   WITH WindowSize DO BEGIN
        {x:=1;}
        y := 20;
   END;
  {$endif}
  SkipAll := FALSE;

 {$ifdef UseWin}
  DLLVersion := GetUnzipDLLVersion;
  write ( 'DLL Version ', Hi ( DLLVersion ), '.' );
  IF lo ( DLLVersion ) < 10 THEN write ( '0' );
  writeln ( LO ( DLLVersion ) );
  {$endif}

  Writeln ( 'Supported ZIP Unzipmethods:' );
  FOR i := 0 TO 8 DO     {8 because of array above}
    IF ( ( 1 SHL i ) AND GetSupportedmethods ) <> 0
      THEN writeln ( Unzipmethods [ i ] );
  Writeln ( '--------------------------' );
  IF paramcount >= 2 THEN BEGIN
      Strpcopy ( thename, paramstr ( 1 ) );
      Strpcopy ( target, paramstr ( 2 ) );
      NoRecursion := Upper ( paramstr ( 3 ) ) = '/D-'; {/D- = don't recurse}
  END ELSE BEGIN
      Writeln;
      write ( 'Please enter ZIP filename: ');
      readln ( sname );
      StrPCopy(thename, sname);
      IF strlen ( thename ) = 0 THEN halt;
      write ( 'Please enter target directory: ');
      readln ( sname );
      StrPCopy(target, sname);
      IF strlen ( target ) = 0 THEN Halt;
  END;

  SetNoRecurseDirs ( NoRecursion );
  {$ifndef __TMT__}
  Writeln ( FileUnzip ( thename, target, '*.*', Report, Ask ), ' files processed.' );
  {$else}
  Writeln ( FileUnzip ( thename, target, '*.*', @Report, @Ask ), ' files processed.' );
  {$endif}
END.
